import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author Jacob Moss 
 * @version 4.0
 */
public class Enemy extends Ship_Stuff
{
    private static final int healthMax = 100;
    public int healthLevel;
    private boolean disabled = false;
    public int enemySpeed = 2;

    public Enemy()
    {
        healthLevel = 0;
        turn(180);
        disabled = false;
        //turn(135+Greenfoot.getRandomNumber(90));
    }

    public void act() 
    {
        move(enemySpeed);
        checkCollision();
        death();

    }    

    private void checkCollision()
    {
        if (getX() < 115)
        {
            getWorld().removeObject(this);
        }
        else
        {
            if (getY() < 97)
            {
                getWorld().removeObject(this);
            }
            else
            {
                if (getY() > 440)
                {
                    getWorld().removeObject(this);
                }
                else {
                    if( !disabled) {
                        if( Greenfoot.getRandomNumber(600) <= 4 ) {
                            getWorld().addObject(new enemyPulse(), getX(), getY());
                        }
                    }
                }
            }
        }
    }

    private void death()
    {
        if (healthLevel >= healthMax) {
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            getWorld().addObject( new debris(), getX(), getY() );
            Greenfoot.playSound("ExplosionEnemy.mp3");
            ((Space1)getWorld()).scoreIncrease();
            if( Greenfoot.getRandomNumber(100) <= 9 ) {
                getWorld().addObject( new HealthPack(), getX(), getY());
            }
            if( Greenfoot.getRandomNumber(100) <= 10 ) {
                getWorld().addObject( new TorpedoPack(), getX(), getY());
            }
            if( Greenfoot.getRandomNumber(70) <= 20 ) {
                ((Space1)getWorld()).getVoyager().dilithiumStore = ((Space1)getWorld()).getVoyager().dilithiumStore+10;
                ((Space1)getWorld()).getVoyager().counterDilithiumStore.setValue(((Space1)getWorld()).getVoyager().dilithiumStore);
            }
            getWorld().removeObject(this);

        }
        else if( healthLevel >= 80 ) {
            enemySpeed = 0;
            //setLocation(getX()+enemySpeed, getY());
            disabled = true;
            this.setImage("enemyDisabled.png");
        }
    }

    public void goodBye()
    {
        getWorld().removeObject(this);
    }
}