import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Space1 here.
 * 
 * @author Jacob Moss
 * @version 4.0
 */
public class Space1 extends World
{
    private Voyager voyager;
    private Enemy enemy;
    public Planet planet;
    public boolean started = false;
    public int spaceLevel = 1;
    private debris debry;

    /**
     * Constructor for objects of class Space1.
     * 
     */
    public Space1()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(900, 500, 1); 

        prepare();
        setPaintOrder(gameOver.class, Voyager.class, Asteroid.class);
    }

    /**
     * linked from buttonBegin class with intention of starting the swarm of enemies
     */
    public void phaseStart()
    {
        started = true;
    }

    /**
     * checks the spaceLevel and increases difficulty.
     */
    public void act()
    {
        if( started == true )
        {
            if( spaceLevel == 1 )
            {
                if(Greenfoot.getRandomNumber(200) <2) {
                    Enemy enemy = new Enemy();
                    addObject(enemy, 899, Greenfoot.getRandomNumber(500));
                }
                if( Greenfoot.getRandomNumber(400) <=1 ) {
                    Asteroid asteroid = new Asteroid();
                    addObject(asteroid, 899, Greenfoot.getRandomNumber(500));
                }
            }
            if( spaceLevel == 2 )
            {
                if(Greenfoot.getRandomNumber(200) <2) {
                    Enemy enemy = new Enemy();
                    addObject(enemy, 899, Greenfoot.getRandomNumber(500));
                }
                if( Greenfoot.getRandomNumber(400) <=2 ) {
                    Asteroid asteroid = new Asteroid();
                    addObject(asteroid, 899, Greenfoot.getRandomNumber(500));
                }
                if( Greenfoot.getRandomNumber(1000) <=2 ) {
                    BorgCube borg = new BorgCube();
                    addObject(borg, 899, Greenfoot.getRandomNumber(500));
                }
            }
            if( spaceLevel == 3 ) {
                if(Greenfoot.getRandomNumber(200) <2) {
                    Enemy enemy = new Enemy();
                    addObject(enemy, 899, Greenfoot.getRandomNumber(500));
                }
                if( Greenfoot.getRandomNumber(400) <=4 ) {
                    Asteroid asteroid = new Asteroid();
                    addObject(asteroid, 899, Greenfoot.getRandomNumber(500));
                }
                if( Greenfoot.getRandomNumber(1000) <=3 ) {
                    BorgCube borg = new BorgCube();
                    addObject(borg, 899, Greenfoot.getRandomNumber(500));
                }
            }
        }
    }

    /**
     * sets the spacelevel
     */
    public void level2()
    {
        spaceLevel = 2;
    }

    /**
     * sets the spacelevel
     */
    public void level3()
    {
        spaceLevel = 3;
    }

    /**
     * if the speed increase button is pressed then it will come to this method, it will first check the speed, 
     * and if the speed is less than the maximum then it will increase the speed.
     */
    public void speedIncrease()
    {
        if( voyager.speed <= 5 ) {
            voyager.speed++;
            voyager.invspeed--;
            voyager.counterSpeed.setValue(voyager.speed);
        }
    }

    /**
     * decreases voyager's speed
     */
    public void speedDecrease()
    {
        if( voyager.speed >= 1 ) {
            voyager.speed--;
            voyager.invspeed++;
            voyager.counterSpeed.setValue(voyager.speed);
        }
    }

    /**
     * Receives instruction from buttonFirePhaser and buttonFireTorpedo
     */
    public void fire(boolean weaponType)
    {
        voyager.fire(weaponType);
    }

    /**
     * Receives instruction from enemy to increase the voyager's score.
     */
    public void scoreIncrease()
    {
        voyager.score();
    }

    /**
     * returns voyager's speed to any class that requests it
     */
    public int getSpeed()
    {
        return voyager.speed;
    }

    /**
     * returns voyagers inverse speed
     */
    public int getInvspeed()
    {
        return voyager.invspeed;
    }

    /**
     * returns voyager to any class that requests it
     */
    public Voyager getVoyager()
    {
        return voyager;
    }

    public debris getDebris()
    {
        return debry;
    }
    
    /**
     * create objects at beginning
     */
    private void prepare()
    {
        voyager = new Voyager();
        addObject(voyager, 251, 271);

        Begin bBegin = new Begin();
        addObject(bBegin, 40, 88);

        Pause buttonPause = new Pause();
        addObject(buttonPause, 42, 179);

        Resume bResume = new Resume();
        addObject(bResume, 42, 230);

        Reset bReset = new Reset();
        addObject(bReset, 40, 142);

        buttonSpeedDecrease bSD = new buttonSpeedDecrease();
        addObject(bSD, 159, 45);

        buttonSpeedIncrease bSI = new buttonSpeedIncrease();
        addObject(bSI, 303, 48);

        Planet planet = new Planet();
        addObject(planet, 450, 240);

        healthLevelNull healthlevelnull = new healthLevelNull();
        addObject(healthlevelnull, 42, 371);
    }
}
