import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Phaser here.
 * 
 * @author Jacob Moss
 * @version 3.0
 */
public class Torpedo extends Ship_Stuff
{
    private final static int lifeLevel = 10;
    private int life;
    private int damage;

    public Torpedo(int damage)
    {
        this.damage = damage;
    }

    public void act() 
    {
        move(6);
        life = 9;
        GreenfootImage torpedoFlicker = getImage();
        int width = Greenfoot.getRandomNumber(6) +3;
        int height = Greenfoot.getRandomNumber(6) +3;
        torpedoFlicker.scale(width, height);
        this.setImage(torpedoFlicker);
        if (getX() < 75)
        {
            getWorld().removeObject(this);
        }
        else
        {
            if (getY() < 67)
            {
                getWorld().removeObject(this);
            }
            else
            {
                if (getY() > 465)
                {
                    getWorld().removeObject(this);
                }
                else 
                {
                    if( getX() == 899 ) {
                        getWorld().removeObject(this);
                    }
                    else
                    {
                        Enemy enemy = (Enemy) getOneIntersectingObject(Enemy.class);
                        if (enemy!= null)
                        {
                            getWorld().addObject( new phaserExplosion(), getX(), getY());
                            enemy.healthLevel = enemy.healthLevel+damage;
                            Greenfoot.playSound("ExplosionDamage.wav");
                            getWorld().removeObject(this);
                        }
                        else {
                            BorgCube cube = (BorgCube) getOneIntersectingObject(BorgCube.class);
                            if (cube!= null)
                            {
                                getWorld().addObject( new phaserExplosion(), getX(), getY());
                                cube.damageOfCube = cube.damageOfCube+damage;
                                Greenfoot.playSound("ExplosionDamage.wav");
                                getWorld().addObject(new debrisSmall(), getX(), getY());
                                getWorld().removeObject(this);
                                return;
                            }

                            else {
                                {
                                    turnTowardsNearestEnemy();
                                }
                            }
                        }
                    }
                }
            } 
        }
    }

    private void lifeGone()
    {
        if (life == lifeLevel)
        {
            getWorld().removeObject(this);
        }
    }

    /**
     * This method will find the nearest enemy and turn towards it (if there is one).
     */
    private void turnTowardsNearestEnemy()
    {
        // get a list of all enemies
        List<Enemy> enemies = getWorld().getObjects(Enemy.class);
        // No
        if (enemies.isEmpty()) 
        {
            // The list is empty. This means that there is no enemy in the world at all. Do nothing.
            return;
        }
        else 
        {
            Enemy nearest = null;                       // A variable to store the nearest enemy
            int nearestDistance = Integer.MAX_VALUE;    // The distance to the currently nearest enemy

            // A loop. Go though every enemy in the 'enemies' list and check whether it is closest
            for (Enemy enem : enemies) 
            {
                int thisDistance = distanceTo(enem);    // the distance to the enemy we're looking at
                if (thisDistance < nearestDistance)     // it it's nearer than the previously nearest...
                {
                    nearest = enem;                     // then the current one is now the nearest
                    nearestDistance = thisDistance;
                }
            }

            // The variable 'nearest' now contains the nearest enemy. Turn towards it.
            turnTowards(nearest.getX(), nearest.getY());

        }

    }

    /**
     * This method returns the distance from this Phaser to a given enemy object.
     * The distance is computed by taking the x and y distances, and then applying
     * Pythagoras to calculate the direct distance.
     */
    private int distanceTo(Enemy enemy)
    {
        int dx = Math.abs (enemy.getX() - this.getX());
        int dy = Math.abs (enemy.getY() - this.getY());

        // Now apply Pythagoras
        return (int) Math.sqrt(dx*dx + dy*dy);
    }
}